﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Mvc.XForms.Examples.Repository;
using Mvc.XForms.Examples.Model;

namespace Mvc.XForms.Tests {
	/// <summary>
	/// Summary description for RepositoryTests
	/// </summary>
	[TestClass]
	public class RepositoryTests {
		private IRepository<Customer> customerRepostiory;

		public RepositoryTests() {
			var db = new InMemoryDataContext();
			customerRepostiory = new InMemoryRepository<Customer>(db);
		}

		private TestContext testContextInstance;

		/// <summary>
		///Gets or sets the test context which provides
		///information about and functionality for the current test run.
		///</summary>
		public TestContext TestContext {
			get {
				return testContextInstance;
			}
			set {
				testContextInstance = value;
			}
		}

		#region Additional test attributes
		//
		// You can use the following additional attributes as you write your tests:
		//
		// Use ClassInitialize to run code before running the first test in the class
		// [ClassInitialize()]
		// public static void MyClassInitialize(TestContext testContext) { }
		//
		// Use ClassCleanup to run code after all tests in a class have run
		// [ClassCleanup()]
		// public static void MyClassCleanup() { }
		//
		// Use TestInitialize to run code before running each test 
		// [TestInitialize()]
		// public void MyTestInitialize() { }
		//
		// Use TestCleanup to run code after each test has run
		// [TestCleanup()]
		// public void MyTestCleanup() { }
		//
		#endregion

		[TestMethod]
		public void Repository_can_return_customer() {
			var customer = customerRepostiory.Get(1);

			Assert.IsNotNull(customer, "Customer is null");
		}
	}
}
