﻿using System;
using Mvc.XForms.Actions.Settings;

namespace Mvc.XForms.Actions {
	public class ActionInsert<TContext> : IActionInsert<TContext> {
		public ActionInsert() {
			Settings = new ActionInsertSettings<TContext>(this);

			// Set defaults
			At = At.Current;
			Position = Position.After;
			Nodeset = string.Empty;
			Event = XFormEvent.DOMActivate;
		}

		public ActionInsertSettings<TContext> Settings { get; private set; }
		public XFormAction Action {
			get { return XFormAction.Insert; }
		}
		public XFormEvent Event { get; set; }
		public string Nodeset { get; set; }
		public At At { get; set; }
		public Position Position { get; set; }
		public string If { get; set; }
		// Not currently implemented
		public string While { get; set; }

		public object ToJson() {
			var json = new {
				type = (int)Action,
				ev = Event.ToScriptName(),
				ns = Nodeset,
				pos = (int)Position,
				at = (int)At,
				cond = If
			};
			return json;
		}
	}
}