﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Linq.Expressions;

using Mvc.XForms.Utilities;

namespace Mvc.XForms.Actions.Settings {
	public class ActionInsertSettings<TContext> {
		private IActionInsert<TContext> action;

		public ActionInsertSettings(IActionInsert<TContext> action) {
			this.action = action;
		}

		public ActionInsertSettings<TContext> Nodeset<T>(Expression<Func<TContext, IList<T>>> nodeset) {
			action.Nodeset = nodeset.Body.ExtractID();
			return this;
		}

		public ActionInsertSettings<TContext> At(At at) {
			action.At = at;
			return this;
		}

		public ActionInsertSettings<TContext> If(string scriptFunction) {
			action.If = scriptFunction;
			return this;
		}
	}
}
