﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Mvc.XForms {
	// Perhaps this functionality should be part of the model with attributes
	public interface IModelItemProperty {
		bool ReadOnly { get; set; }
		bool Required { get; set; }
		// Relevant and calculate should be and XPath expression. As XPath is
		// replaced with LINQ in Mvc XForms, this should take a LINQ expression.
		// This is not possible without a full LINQ to JavaScript implementation,
		// so these are simply pointers to JavaScript functions.
		string Calculate { get; set; }
		// Constraint is an abstraction of a validation rule
		string Constraint { get; set; }
		// type and p3ptype not used
	}
}
