﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Mvc.XForms.UI {
	public class GridFormatterFactory {
		private static GridFormatterFactory instance = new GridFormatterFactory();
		private IGridFormatter gridFormat = new DefaultGridFormatter(); 
		private IPagerFormatter pagerFormat = new DefaultPagerFormat();

		public static GridFormatterFactory Current {
            get { return instance; }
        }

		public IGridFormatter Formatter {
			get { return gridFormat; }
			set { gridFormat = value; }
		}

		public IPagerFormatter PagerFormatter {
			get { return pagerFormat; }
			set { pagerFormat = value; }
		}
	}
}
