﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace Mvc.XForms.UI {
	/// <summary>
	/// An interface for paging parameters for use with the HTML grid
	/// </summary>
	public interface IPaged : IPagedParameters {
		/// <summary>
		/// The total number of pages in the result set
		/// </summary>
		int PageCount { get; }

		/// <summary>
		/// The total number of records in the result set
		/// </summary>
		int TotalCount { get; }

		/// <summary>
		/// True if there is a page before the current page
		/// </summary>
		bool IsPrevious { get; }

		/// <summary>
		/// True if there is a page after the current page
		/// </summary>
		bool IsNext { get; }
	}
}