﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Collections.Specialized;
using System.Web.UI.WebControls;

namespace Mvc.XForms.UI {
	/// <summary>
	/// An interface for paged parameters for use with the HTML grid
	/// </summary>
	public interface IPagedParameters {
		/// <summary>
		/// The key of the NameValueCollection that corresponds to the value
		/// of the page index expression
		/// </summary>
		string PageIndexKey { get; }

		/// <summary>
		/// The current page index
		/// </summary>
		int PageIndex { get; }

		/// <summary>
		/// The number of pages per row in the result set
		/// </summary>
		int PageSize { get; }
	}
}